<template>
  <section class="container">
    <div class="row">
      <div class="col col-md-6 offset-md-3">
        <div class="messenger-page-content">
          <h1 class="text-center mb-3">Nuxt Messenger</h1>
          <div class="messenger-block">
            <div id="messegeBox" class="messenger-messeges p-3">
              <div v-for="(messege, index) in messeges"
              :key="index" class="my-3">
                <h6 class="mb-1">{{messege.user_name}}</h6>
                <b-card>
                  <b-card-text>{{ messege.content }}</b-card-text>
                </b-card>
              </div>
            </div>
            <b-form @submit="onSubmit">
              <b-input-group class="mt-3">
                <b-form-input :state="sended" v-model="messege"></b-form-input>
                <b-input-group-append>
                  <b-button v-if="messege.length" type="submit" variant="info">Send</b-button>
                </b-input-group-append>
              </b-input-group>
              <b-form-invalid-feedback :state="sended">
                Your messege has not been sent.
              </b-form-invalid-feedback>
            </b-form>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import { mapGetters,mapMutations, mapActions  } from 'vuex';
export default {
  data() {
    return {
      messege: '',
      sended: null,
      timer: null
    }
  },
  async fetch({ store }) {
    await store.dispatch('messege/getItems');
  },
  computed: {
    ...mapGetters({
      messeges: 'messege/items',
      user: 'user/user'
    }),
  },
  mounted() {
    if(!this.user.name.length){
      this.$router.push('/');
    }
  },
  created(){
    this.upDateMesseges();
  },
  methods: {
    ...mapActions({
      getItems: 'messege/getItems',
      addItem: 'messege/addItem',
    }),
    upDateMesseges(){
      this.timer = setInterval(() => {
  			this.getItems();
  		}, 3000)
    },
    onSubmit(e) {
        e.preventDefault()
        this.addItem({
          user_name: this.user.name,
          content: this.messege
        }).then( () => {
            this.getItems().then( () => {
              this.messege = '';
              this.sended = null;
              this.scrollBottom();
            });
        }).catch(error => {
          this.sended = false;
        });;
      },
      scrollBottom(){
        let messegeBox = this.$el.querySelector("#messegeBox");
        messegeBox.scrollTop = messegeBox.scrollHeight;
      }
  },
  beforeDestroy () {
  	clearInterval(this.timer)
  }
}
</script>
